#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    int n, q, veg=0;

    cin>>n>>q;

    vector <int> x;

    for(int i=1; i<=n; i++)
    {
        int d1, p1;
        cin>>d1>>p1;

        for(int j=1; j<=d1; j++)
            x.push_back(0);
        for(int j=1; j<=p1; j++)
            x.push_back(0);

        for(int j=d1; j<d1+p1; j++)
        {
            x[j]=1;
        }
    }
    for(int i=0; i<q; i++)
    {
        veg=0;
        int q1;
        cin>>q1;
        for(int j=1; j<=q1; j++)
        {
            if(x[j]==1)
                veg++;
        }
        cout<<veg<<endl;
    }

    return 0;
}